/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
import * as Types from './types.js';
/**
 * Typing for the body of the request made by newBooking()
 * @category newBooking()
 */
export type NewBookingBody = {
    /**
     * List of devices which should be added.
     */
    Devices: Types.Device<'request'>[];
    /**
     * A time slot represents a slice of time used for bookings.
     */
    Time: Types.Timeslot<'request'>;
    /**
     * Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.
     */
    Type?: 'normal';
    [k: string]: unknown;
};
/**
 * Typing for all possible responses to the request made by newBooking()
 * @category newBooking()
 */
export type NewBookingResponse = NewBookingSuccessResponse | NewBookingErrorResponse;
/**
 * Typing for all successful responses to the request made by newBooking()
 * @category newBooking()
 */
export type NewBookingSuccessResponse = NewBookingResponse200;
/**
 * Typing for all error responses to the request made by newBooking()
 * @category newBooking()
 */
export type NewBookingErrorResponse = NewBookingResponse401 | NewBookingResponse403 | NewBookingResponse500 | NewBookingResponse503;
/**
 * Typing for a response with status 200 to the request made by newBooking()
 * @category newBooking()
 */
export interface NewBookingResponse200 extends Types.SuccessResponse {
    status: 200;
    headers?: {
        [k: string]: string | undefined;
    };
    body: {
        /**
         * ID at which the booking can be managed.
         */
        BookingID: string;
        [k: string]: unknown;
    };
}
/**
 * Typing for a response with status 401 to the request made by newBooking()
 * @category newBooking()
 */
export interface NewBookingResponse401 extends Types.ErrorResponse {
    status: 401;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 403 to the request made by newBooking()
 * @category newBooking()
 */
export interface NewBookingResponse403 extends Types.ErrorResponse {
    status: 403;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 500 to the request made by newBooking()
 * @category newBooking()
 */
export interface NewBookingResponse500 extends Types.ErrorResponse {
    status: 500;
    headers?: {
        [k: string]: string | undefined;
    };
    body: string;
}
/**
 * Typing for a response with status 503 to the request made by newBooking()
 * @category newBooking()
 */
export interface NewBookingResponse503 extends Types.ErrorResponse {
    status: 503;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for the parameters of the request made by updateBooking()
 * @category updateBooking()
 */
export type UpdateBookingParameters = {
    ID: string;
};
/**
 * Typing for the body of the request made by updateBooking()
 * @category updateBooking()
 */
export type UpdateBookingBody = {
    /**
     * Expresses whether the devices should be locked. Must match current status of booking. Is assumed to be false if not set.
     */
    Locked?: boolean;
    /**
     * List of devices which should be added.
     */
    Devices?: Types.Device<'request'>[];
    [k: string]: unknown;
} | {
    /**
     * Callback which should be called at changes.
     */
    Callback?: string;
    [k: string]: unknown;
};
/**
 * Typing for all possible responses to the request made by updateBooking()
 * @category updateBooking()
 */
export type UpdateBookingResponse = UpdateBookingSuccessResponse | UpdateBookingErrorResponse;
/**
 * Typing for all successful responses to the request made by updateBooking()
 * @category updateBooking()
 */
export type UpdateBookingSuccessResponse = UpdateBookingResponse200;
/**
 * Typing for all error responses to the request made by updateBooking()
 * @category updateBooking()
 */
export type UpdateBookingErrorResponse = UpdateBookingResponse400 | UpdateBookingResponse401 | UpdateBookingResponse403 | UpdateBookingResponse404 | UpdateBookingResponse423 | UpdateBookingResponse500 | UpdateBookingResponse503;
/**
 * Typing for a response with status 200 to the request made by updateBooking()
 * @category updateBooking()
 */
export interface UpdateBookingResponse200 extends Types.SuccessResponse {
    status: 200;
    headers?: {
        [k: string]: string | undefined;
    };
    body: {
        BookingID: string;
        [k: string]: unknown;
    };
}
/**
 * Typing for a response with status 400 to the request made by updateBooking()
 * @category updateBooking()
 */
export interface UpdateBookingResponse400 extends Types.ErrorResponse {
    status: 400;
    headers?: {
        [k: string]: string | undefined;
    };
    body: string;
}
/**
 * Typing for a response with status 401 to the request made by updateBooking()
 * @category updateBooking()
 */
export interface UpdateBookingResponse401 extends Types.ErrorResponse {
    status: 401;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 403 to the request made by updateBooking()
 * @category updateBooking()
 */
export interface UpdateBookingResponse403 extends Types.ErrorResponse {
    status: 403;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 404 to the request made by updateBooking()
 * @category updateBooking()
 */
export interface UpdateBookingResponse404 extends Types.ErrorResponse {
    status: 404;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 423 to the request made by updateBooking()
 * @category updateBooking()
 */
export interface UpdateBookingResponse423 extends Types.ErrorResponse {
    status: 423;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 500 to the request made by updateBooking()
 * @category updateBooking()
 */
export interface UpdateBookingResponse500 extends Types.ErrorResponse {
    status: 500;
    headers?: {
        [k: string]: string | undefined;
    };
    body: string;
}
/**
 * Typing for a response with status 503 to the request made by updateBooking()
 * @category updateBooking()
 */
export interface UpdateBookingResponse503 extends Types.ErrorResponse {
    status: 503;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for the parameters of the request made by deleteBooking()
 * @category deleteBooking()
 */
export type DeleteBookingParameters = {
    ID: string;
};
/**
 * Typing for all possible responses to the request made by deleteBooking()
 * @category deleteBooking()
 */
export type DeleteBookingResponse = DeleteBookingSuccessResponse | DeleteBookingErrorResponse;
/**
 * Typing for all successful responses to the request made by deleteBooking()
 * @category deleteBooking()
 */
export type DeleteBookingSuccessResponse = DeleteBookingResponse200;
/**
 * Typing for all error responses to the request made by deleteBooking()
 * @category deleteBooking()
 */
export type DeleteBookingErrorResponse = DeleteBookingResponse401 | DeleteBookingResponse403 | DeleteBookingResponse404 | DeleteBookingResponse423 | DeleteBookingResponse500 | DeleteBookingResponse503;
/**
 * Typing for a response with status 200 to the request made by deleteBooking()
 * @category deleteBooking()
 */
export interface DeleteBookingResponse200 extends Types.SuccessResponse {
    status: 200;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 401 to the request made by deleteBooking()
 * @category deleteBooking()
 */
export interface DeleteBookingResponse401 extends Types.ErrorResponse {
    status: 401;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 403 to the request made by deleteBooking()
 * @category deleteBooking()
 */
export interface DeleteBookingResponse403 extends Types.ErrorResponse {
    status: 403;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 404 to the request made by deleteBooking()
 * @category deleteBooking()
 */
export interface DeleteBookingResponse404 extends Types.ErrorResponse {
    status: 404;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 423 to the request made by deleteBooking()
 * @category deleteBooking()
 */
export interface DeleteBookingResponse423 extends Types.ErrorResponse {
    status: 423;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 500 to the request made by deleteBooking()
 * @category deleteBooking()
 */
export interface DeleteBookingResponse500 extends Types.ErrorResponse {
    status: 500;
    headers?: {
        [k: string]: string | undefined;
    };
    body: string;
}
/**
 * Typing for a response with status 503 to the request made by deleteBooking()
 * @category deleteBooking()
 */
export interface DeleteBookingResponse503 extends Types.ErrorResponse {
    status: 503;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for the parameters of the request made by getBooking()
 * @category getBooking()
 */
export type GetBookingParameters = {
    ID: string;
};
/**
 * Typing for all possible responses to the request made by getBooking()
 * @category getBooking()
 */
export type GetBookingResponse = GetBookingSuccessResponse | GetBookingErrorResponse;
/**
 * Typing for all successful responses to the request made by getBooking()
 * @category getBooking()
 */
export type GetBookingSuccessResponse = GetBookingResponse200;
/**
 * Typing for all error responses to the request made by getBooking()
 * @category getBooking()
 */
export type GetBookingErrorResponse = GetBookingResponse401 | GetBookingResponse403 | GetBookingResponse404 | GetBookingResponse500 | GetBookingResponse503;
/**
 * Typing for a response with status 200 to the request made by getBooking()
 * @category getBooking()
 */
export interface GetBookingResponse200 extends Types.SuccessResponse {
    status: 200;
    headers?: {
        [k: string]: string | undefined;
    };
    body: {
        /**
         * A booking in the booking system.
         */
        Booking: Types.Booking<'response'>;
        /**
         * Shows if the booking is in a locked status.
         */
        Locked: boolean;
        [k: string]: unknown;
    };
}
/**
 * Typing for a response with status 401 to the request made by getBooking()
 * @category getBooking()
 */
export interface GetBookingResponse401 extends Types.ErrorResponse {
    status: 401;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 403 to the request made by getBooking()
 * @category getBooking()
 */
export interface GetBookingResponse403 extends Types.ErrorResponse {
    status: 403;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 404 to the request made by getBooking()
 * @category getBooking()
 */
export interface GetBookingResponse404 extends Types.ErrorResponse {
    status: 404;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 500 to the request made by getBooking()
 * @category getBooking()
 */
export interface GetBookingResponse500 extends Types.ErrorResponse {
    status: 500;
    headers?: {
        [k: string]: string | undefined;
    };
    body: string;
}
/**
 * Typing for a response with status 503 to the request made by getBooking()
 * @category getBooking()
 */
export interface GetBookingResponse503 extends Types.ErrorResponse {
    status: 503;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for the parameters of the request made by destroyBooking()
 * @category destroyBooking()
 */
export type DestroyBookingParameters = {
    ID: string;
};
/**
 * Typing for all possible responses to the request made by destroyBooking()
 * @category destroyBooking()
 */
export type DestroyBookingResponse = DestroyBookingSuccessResponse | DestroyBookingErrorResponse;
/**
 * Typing for all successful responses to the request made by destroyBooking()
 * @category destroyBooking()
 */
export type DestroyBookingSuccessResponse = DestroyBookingResponse200;
/**
 * Typing for all error responses to the request made by destroyBooking()
 * @category destroyBooking()
 */
export type DestroyBookingErrorResponse = DestroyBookingResponse401 | DestroyBookingResponse403 | DestroyBookingResponse404 | DestroyBookingResponse423 | DestroyBookingResponse500 | DestroyBookingResponse503;
/**
 * Typing for a response with status 200 to the request made by destroyBooking()
 * @category destroyBooking()
 */
export interface DestroyBookingResponse200 extends Types.SuccessResponse {
    status: 200;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 401 to the request made by destroyBooking()
 * @category destroyBooking()
 */
export interface DestroyBookingResponse401 extends Types.ErrorResponse {
    status: 401;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 403 to the request made by destroyBooking()
 * @category destroyBooking()
 */
export interface DestroyBookingResponse403 extends Types.ErrorResponse {
    status: 403;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 404 to the request made by destroyBooking()
 * @category destroyBooking()
 */
export interface DestroyBookingResponse404 extends Types.ErrorResponse {
    status: 404;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 423 to the request made by destroyBooking()
 * @category destroyBooking()
 */
export interface DestroyBookingResponse423 extends Types.ErrorResponse {
    status: 423;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
/**
 * Typing for a response with status 500 to the request made by destroyBooking()
 * @category destroyBooking()
 */
export interface DestroyBookingResponse500 extends Types.ErrorResponse {
    status: 500;
    headers?: {
        [k: string]: string | undefined;
    };
    body: string;
}
/**
 * Typing for a response with status 503 to the request made by destroyBooking()
 * @category destroyBooking()
 */
export interface DestroyBookingResponse503 extends Types.ErrorResponse {
    status: 503;
    headers?: {
        [k: string]: string | undefined;
    };
    body?: undefined;
}
//# sourceMappingURL=signatures.d.ts.map