import * as Signatures from './signatures.js';
import { ResponseData } from './types.js';
/**
 * This function validates the inputs to listDevices()
 */
export declare function validateListDevicesInput(): boolean;
/**
 * This function validates the outputs of listDevices()
 */
export declare function validateListDevicesOutput(response: ResponseData): response is Signatures.ListDevicesResponse;
/**
 * This function validates the inputs to createDevice()
 */
export declare function validateCreateDeviceInput(parameters: Signatures.CreateDeviceParameters, body: Signatures.CreateDeviceBody): boolean;
/**
 * This function validates the outputs of createDevice()
 */
export declare function validateCreateDeviceOutput(response: ResponseData): response is Signatures.CreateDeviceResponse;
/**
 * This function validates the inputs to getDevice()
 */
export declare function validateGetDeviceInput(parameters: Signatures.GetDeviceParameters): boolean;
/**
 * This function validates the outputs of getDevice()
 */
export declare function validateGetDeviceOutput(response: ResponseData): response is Signatures.GetDeviceResponse;
/**
 * This function validates the inputs to updateDevice()
 */
export declare function validateUpdateDeviceInput(parameters: Signatures.UpdateDeviceParameters, body: Signatures.UpdateDeviceBody): boolean;
/**
 * This function validates the outputs of updateDevice()
 */
export declare function validateUpdateDeviceOutput(response: ResponseData): response is Signatures.UpdateDeviceResponse;
/**
 * This function validates the inputs to deleteDevice()
 */
export declare function validateDeleteDeviceInput(parameters: Signatures.DeleteDeviceParameters): boolean;
/**
 * This function validates the outputs of deleteDevice()
 */
export declare function validateDeleteDeviceOutput(response: ResponseData): response is Signatures.DeleteDeviceResponse;
/**
 * This function validates the inputs to instantiateDevice()
 */
export declare function validateInstantiateDeviceInput(parameters: Signatures.InstantiateDeviceParameters): boolean;
/**
 * This function validates the outputs of instantiateDevice()
 */
export declare function validateInstantiateDeviceOutput(response: ResponseData): response is Signatures.InstantiateDeviceResponse;
/**
 * This function validates the inputs to getDeviceAvailability()
 */
export declare function validateGetDeviceAvailabilityInput(parameters: Signatures.GetDeviceAvailabilityParameters): boolean;
/**
 * This function validates the outputs of getDeviceAvailability()
 */
export declare function validateGetDeviceAvailabilityOutput(response: ResponseData): response is Signatures.GetDeviceAvailabilityResponse;
/**
 * This function validates the inputs to deleteDeviceAvailabilityRules()
 */
export declare function validateDeleteDeviceAvailabilityRulesInput(parameters: Signatures.DeleteDeviceAvailabilityRulesParameters): boolean;
/**
 * This function validates the outputs of deleteDeviceAvailabilityRules()
 */
export declare function validateDeleteDeviceAvailabilityRulesOutput(response: ResponseData): response is Signatures.DeleteDeviceAvailabilityRulesResponse;
/**
 * This function validates the inputs to addDeviceAvailabilityRules()
 */
export declare function validateAddDeviceAvailabilityRulesInput(parameters: Signatures.AddDeviceAvailabilityRulesParameters, body: Signatures.AddDeviceAvailabilityRulesBody): boolean;
/**
 * This function validates the outputs of addDeviceAvailabilityRules()
 */
export declare function validateAddDeviceAvailabilityRulesOutput(response: ResponseData): response is Signatures.AddDeviceAvailabilityRulesResponse;
/**
 * This function validates the inputs to createWebsocketToken()
 */
export declare function validateCreateWebsocketTokenInput(parameters: Signatures.CreateWebsocketTokenParameters): boolean;
/**
 * This function validates the outputs of createWebsocketToken()
 */
export declare function validateCreateWebsocketTokenOutput(response: ResponseData): response is Signatures.CreateWebsocketTokenResponse;
/**
 * This function validates the inputs to sendSignalingMessage()
 */
export declare function validateSendSignalingMessageInput(parameters: Signatures.SendSignalingMessageParameters, body: Signatures.SendSignalingMessageBody): boolean;
/**
 * This function validates the outputs of sendSignalingMessage()
 */
export declare function validateSendSignalingMessageOutput(response: ResponseData): response is Signatures.SendSignalingMessageResponse;
/**
 * This function validates the inputs to listPeerconnections()
 */
export declare function validateListPeerconnectionsInput(): boolean;
/**
 * This function validates the outputs of listPeerconnections()
 */
export declare function validateListPeerconnectionsOutput(response: ResponseData): response is Signatures.ListPeerconnectionsResponse;
/**
 * This function validates the inputs to createPeerconnection()
 */
export declare function validateCreatePeerconnectionInput(parameters: Signatures.CreatePeerconnectionParameters, body: Signatures.CreatePeerconnectionBody): boolean;
/**
 * This function validates the outputs of createPeerconnection()
 */
export declare function validateCreatePeerconnectionOutput(response: ResponseData): response is Signatures.CreatePeerconnectionResponse;
/**
 * This function validates the inputs to getPeerconnection()
 */
export declare function validateGetPeerconnectionInput(parameters: Signatures.GetPeerconnectionParameters): boolean;
/**
 * This function validates the outputs of getPeerconnection()
 */
export declare function validateGetPeerconnectionOutput(response: ResponseData): response is Signatures.GetPeerconnectionResponse;
/**
 * This function validates the inputs to deletePeerconnection()
 */
export declare function validateDeletePeerconnectionInput(parameters: Signatures.DeletePeerconnectionParameters): boolean;
/**
 * This function validates the outputs of deletePeerconnection()
 */
export declare function validateDeletePeerconnectionOutput(response: ResponseData): response is Signatures.DeletePeerconnectionResponse;
/**
 * This function validates the inputs to patchPeerconnectionDeviceStatus()
 */
export declare function validatePatchPeerconnectionDeviceStatusInput(parameters: Signatures.PatchPeerconnectionDeviceStatusParameters, body: Signatures.PatchPeerconnectionDeviceStatusBody): boolean;
/**
 * This function validates the outputs of patchPeerconnectionDeviceStatus()
 */
export declare function validatePatchPeerconnectionDeviceStatusOutput(response: ResponseData): response is Signatures.PatchPeerconnectionDeviceStatusResponse;
//# sourceMappingURL=requestValidation.d.ts.map