import { RequestHandler } from 'express';
import { Client as BookingBackendClient } from './booking-backend/client.js';
import { Client as BookingFrontendClient } from './booking-frontend/client.js';
import { Client as DeviceClient } from './device/client.js';
import { Client as ScheduleServiceClient } from './schedule-service/client.js';
export declare const device: DeviceClient;
export declare const booking: {
    backend: BookingBackendClient;
    frontend: BookingFrontendClient;
    schedule: ScheduleServiceClient;
};
export declare const clients: {
    device: DeviceClient;
    booking: {
        backend: BookingBackendClient;
        frontend: BookingFrontendClient;
        schedule: ScheduleServiceClient;
    };
};
export type Clients = typeof clients;
declare global {
    namespace Express {
        interface Request {
            clients: typeof clients;
        }
    }
}
export declare const middleware: RequestHandler;
//# sourceMappingURL=index.d.ts.map