/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
import * as Signatures from './signatures.js';
import * as Types from './types.js';
/**
 * This error class should be used if an error occurs during validation of a request/response.
 * @category Errors
 */
export declare class ValidationError extends Error {
    errors: unknown;
    constructor(message: string, errors: unknown);
}
/**
 * This error class should be used if an error occurs while fetching a request.
 * @category Errors
 */
export declare class FetchError extends Error {
    constructor(message: string);
}
/**
 * This error class should be used if the response of the server has a status
 * greater than or equal to 400. This error should contain the validated response.
 * @category Errors
 */
export declare class UnsuccessfulRequestError extends Error {
    response: Types.ResponseData;
    constructor(message: string, response: Types.ResponseData);
}
/**
 * This error class should be used if the validation of an url fails.
 * @category Errors
 */
export declare class InvalidUrlError extends Error {
    constructor(message: string);
}
/**
 * Client for the use of the Crosslab API
 * @category Client
 */
export declare class Client {
    readonly baseUrl: string;
    readonly serviceUrl: string;
    accessToken: string;
    private fixedHeaders;
    private fetch;
    /**
     * @category Constructors
     */
    constructor(baseUrl: string, options: {
        serviceUrl?: string;
        accessToken?: string;
        fixedHeaders?: [string, string][];
    });
    /**
     * Returns the free / booked times for given experiment.
     *
     * @param body
     * @param options.url
     * Url of the  to be used.
     *
     * @throws {@link FetchError | FetchError }
     * Thrown if fetch fails.
     * @throws {@link ValidationError | ValidationError }
     * Thrown if the request/response validation fails.
     * @throws {@link InvalidUrlError | InvalidUrlError }
     * Thrown if the provided url is not valid for this request.
     * @throws {@link UnsuccessfulRequestError | UnsuccessfulRequestError }
     * Thrown if response is validated but has status greater than or equal to 400.
     *
     * @returns
     * Timetable of free/booked time. If 'Combined' is set to true, an array with only one entry is returned containing the combined timetable.
     */
    schedule(body: {
        /**
         * An experiment describes a set of devices and how they should be connected (potentially among other metadata).
         */
        Experiment: Types.Experiment<'request'>;
        /**
         * A time slot represents a slice of time used for bookings.
         */
        Time: Types.Timeslot<'request'>;
        /**
         * If true, show only one timetable per device instead of one for all available physical devices.
         */
        Combined?: boolean;
        /**
         * (private) Show only devices of this institution. Give an error if a device of an other institution is requested.
         */
        onlyOwn?: boolean;
        [k: string]: unknown;
    } | undefined, options?: {
        headers?: [string, string][];
        url?: string;
    }): Promise<Signatures.ScheduleSuccessResponse['body']>;
}
//# sourceMappingURL=client.d.ts.map